chiark / gitweb /
finalise 0.12
[dgit.git] / dgit
1 #!/usr/bin/perl -w
2 # dgit
3 # Integration between git and Debian-style archives
4 #
5 # Copyright (C)2013 Ian Jackson
6 #
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
11 #
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #
17 # You should have received a copy of the GNU General Public License
18 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 use strict;
21
22 use IO::Handle;
23 use Data::Dumper;
24 use LWP::UserAgent;
25 use Dpkg::Control::Hash;
26 use File::Path;
27 use File::Basename;
28 use Dpkg::Version;
29 use POSIX;
30
31 our $isuite = 'unstable';
32 our $idistro;
33 our $package;
34
35 our $sign = 1;
36 our $dryrun = 0;
37 our $changesfile;
38 our $new_package = 0;
39 our $ignoredirty = 0;
40 our $noquilt = 0;
41 our $existing_package = 'dpkg';
42 our $cleanmode = 'dpkg-source';
43
44 our %format_ok = map { $_=>1 } ("1.0","3.0 (native)","3.0 (quilt)");
45
46 our (@git) = qw(git);
47 our (@dget) = qw(dget);
48 our (@dput) = qw(dput);
49 our (@debsign) = qw(debsign);
50 our (@sbuild) = qw(sbuild -A);
51 our (@dpkgbuildpackage) = qw(dpkg-buildpackage -i\.git/ -I.git);
52 our (@dpkgsource) = qw(dpkg-source -i\.git/ -I.git);
53 our (@dpkggenchanges) = qw(dpkg-genchanges);
54 our (@mergechanges) = qw(mergechanges -f);
55 our (@changesopts) = ('');
56
57 our %opts_opt_map = ('dget' => \@dget,
58                      'dput' => \@dput,
59                      'debsign' => \@debsign,
60                      'sbuild' => \@sbuild,
61                      'dpkg-source' => \@dpkgsource,
62                      'dpkg-buildpackage' => \@dpkgbuildpackage,
63                      'dpkg-genchanges' => \@dpkggenchanges,
64                      'ch' => \@changesopts,
65                      'mergechanges' => \@mergechanges);
66
67 our $keyid;
68
69 our $debug = 0;
70 open DEBUG, ">/dev/null" or die $!;
71
72 our $remotename = 'dgit';
73 our @ourdscfield = qw(Dgit Vcs-Dgit-Master);
74 our $branchprefix = 'dgit';
75 our $csuite;
76
77 sub lbranch () { return "$branchprefix/$csuite"; }
78 my $lbranch_re = '^refs/heads/'.$branchprefix.'/([^/.]+)$';
79 sub lref () { return "refs/heads/".lbranch(); }
80 sub lrref () { return "refs/remotes/$remotename/$branchprefix/$csuite"; }
81 sub rrref () { return "refs/$branchprefix/$csuite"; }
82 sub debiantag ($) { 
83     my ($v) = @_;
84     $v =~ y/~:/_%/;
85     return "debian/$v";
86 }
87
88 sub stripepoch ($) {
89     my ($vsn) = @_;
90     $vsn =~ s/^\d+\://;
91     return $vsn;
92 }
93
94 sub dscfn ($) {
95     my ($vsn) = @_;
96     return "${package}_".(stripepoch $vsn).".dsc";
97 }
98
99 sub changesopts () { return @changesopts[1..$#changesopts]; }
100
101 our $us = 'dgit';
102
103 sub fail { die "$us: @_\n"; }
104
105 sub badcfg { print STDERR "$us: invalid configuration: @_\n"; exit 12; }
106
107 sub no_such_package () {
108     print STDERR "$us: package $package does not exist in suite $isuite\n";
109     exit 4;
110 }
111
112 sub fetchspec () {
113     local $csuite = '*';
114     return  "+".rrref().":".lrref();
115 }
116
117 our $ua;
118
119 sub url_get {
120     if (!$ua) {
121         $ua = LWP::UserAgent->new();
122         $ua->env_proxy;
123     }
124     my $what = $_[$#_];
125     print "downloading $what...\n";
126     my $r = $ua->get(@_) or die $!;
127     return undef if $r->code == 404;
128     $r->is_success or fail "failed to fetch $what: ".$r->status_line;
129     return $r->decoded_content();
130 }
131
132 our ($dscdata,$dscurl,$dsc);
133
134 sub printcmd {
135     my $fh = shift @_;
136     my $intro = shift @_;
137     print $fh $intro or die $!;
138     local $_;
139     foreach my $a (@_) {
140         $_ = $a;
141         if (s{['\\]}{\\$&}g || m{\s} || m{[^-_./0-9a-z]}i) {
142             print $fh " '$_'" or die $!;
143         } else {
144             print $fh " $_" or die $!;
145         }
146     }
147     print $fh "\n" or die $!;
148 }
149
150 sub failedcmd {
151     { local ($!); printcmd \*STDERR, "$_[0]: failed command:", @_ or die $!; };
152     if ($!) {
153         fail "failed to fork/exec: $!";
154     } elsif (!($? & 0xff)) {
155         fail "subprocess failed with error exit status ".($?>>8);
156     } elsif ($?) {
157         fail "subprocess crashed (wait status $?)";
158     } else {
159         fail "subprocess produced invalid output";
160     }
161 }
162
163 sub runcmd {
164     printcmd(\*DEBUG,"+",@_) if $debug>0;
165     $!=0; $?=0;
166     failedcmd @_ if system @_;
167 }
168
169 sub printdone {
170     if (!$dryrun) {
171         print "dgit ok: @_\n";
172     } else {
173         print "would be ok: @_ (but dry run only)\n";
174     }
175 }
176
177 sub cmdoutput_errok {
178     die Dumper(\@_)." ?" if grep { !defined } @_;
179     printcmd(\*DEBUG,"|",@_) if $debug>0;
180     open P, "-|", @_ or die $!;
181     my $d;
182     $!=0; $?=0;
183     { local $/ = undef; $d = <P>; }
184     die $! if P->error;
185     if (!close P) { print DEBUG "=>!$?\n" if $debug>0; return undef; }
186     chomp $d;
187     $d =~ m/^.*/;
188     print DEBUG "=> \`$&'",(length $' ? '...' : ''),"\n" if $debug>0; #';
189     return $d;
190 }
191
192 sub cmdoutput {
193     my $d = cmdoutput_errok @_;
194     defined $d or failedcmd @_;
195     return $d;
196 }
197
198 sub dryrun_report {
199     printcmd(\*STDOUT,"#",@_);
200 }
201
202 sub runcmd_ordryrun {
203     if (!$dryrun) {
204         runcmd @_;
205     } else {
206         dryrun_report @_;
207     }
208 }
209
210 our $helpmsg = <<END;
211 main usages:
212   dgit [dgit-opts] clone [dgit-opts] package [suite] [./dir|/dir]
213   dgit [dgit-opts] fetch|pull [dgit-opts] [suite]
214   dgit [dgit-opts] build [git-buildpackage-opts|dpkg-buildpackage-opts]
215   dgit [dgit-opts] push [dgit-opts] [suite]
216 important dgit options:
217   -k<keyid>           sign tag and package with <keyid> instead of default
218   --dry-run -n        do not change anything, but go through the motions
219   --new -N            allow introducing a new package
220   --debug -D          increase debug level
221   -c<name>=<value>    set git config option (used directly by dgit too)
222 END
223
224 our $later_warning_msg = <<END;
225 Perhaps the upload is stuck in incoming.  Using the version from git.
226 END
227
228 sub badusage {
229     print STDERR "$us: @_\n", $helpmsg or die $!;
230     exit 8;
231 }
232
233 sub helponly () {
234     print $helpmsg or die $!;
235     exit 0;
236 }
237
238 our %defcfg = ('dgit.default.distro' => 'debian',
239                'dgit.default.username' => '',
240                'dgit.default.archive-query-default-component' => 'main',
241                'dgit.default.ssh' => 'ssh',
242                'dgit-distro.debian.git-host' => 'git.debian.org',
243                'dgit-distro.debian.git-proto' => 'git+ssh://',
244                'dgit-distro.debian.git-path' => '/git/dgit-repos/repos',
245                'dgit-distro.debian.git-check' => 'ssh-cmd',
246                'dgit-distro.debian.git-create' => 'ssh-cmd',
247                'dgit-distro.debian.sshdakls-host' => 'coccia.debian.org',
248                'dgit-distro.debian.sshdakls-dir' =>
249                    '/srv/ftp-master.debian.org/ftp/dists',
250                'dgit-distro.debian.mirror' => 'http://ftp.debian.org/debian/');
251
252 sub cfg {
253     foreach my $c (@_) {
254         return undef if $c =~ /RETURN-UNDEF/;
255         my @cmd = (@git, qw(config --), $c);
256         my $v;
257         {
258             local ($debug) = $debug-1;
259             $v = cmdoutput_errok @cmd;
260         };
261         if ($?==0) {
262             return $v;
263         } elsif ($?!=256) {
264             failedcmd @cmd;
265         }
266         my $dv = $defcfg{$c};
267         return $dv if defined $dv;
268     }
269     badcfg "need value for one of: @_";
270 }
271
272 sub access_distro () {
273     return cfg("dgit-suite.$isuite.distro",
274                "dgit.default.distro");
275 }
276
277 sub access_cfg (@) {
278     my (@keys) = @_;
279     my $distro = $idistro || access_distro();
280     my $value = cfg(map { ("dgit-distro.$distro.$_",
281                            "dgit.default.$_") } @keys);
282     return $value;
283 }
284
285 sub access_someuserhost ($) {
286     my ($some) = @_;
287     my $user = access_cfg("$some-user",'username');
288     my $host = access_cfg("$some-host");
289     return length($user) ? "$user\@$host" : $host;
290 }
291
292 sub access_gituserhost () {
293     return access_someuserhost('git');
294 }
295
296 sub access_giturl () {
297     my $url = access_cfg('git-url','RETURN-UNDEF');
298     if (!defined $url) {
299         $url =
300             access_cfg('git-proto').
301             access_gituserhost().
302             access_cfg('git-path');
303     }
304     return "$url/$package.git";
305 }              
306
307 sub parsecontrolfh ($$@) {
308     my ($fh, $desc, @opts) = @_;
309     my %opts = ('name' => $desc, @opts);
310     my $c = Dpkg::Control::Hash->new(%opts);
311     $c->parse($fh) or die "parsing of $desc failed";
312     return $c;
313 }
314
315 sub parsecontrol {
316     my ($file, $desc) = @_;
317     my $fh = new IO::Handle;
318     open $fh, '<', $file or die "$file: $!";
319     my $c = parsecontrolfh($fh,$desc);
320     $fh->error and die $!;
321     close $fh;
322     return $c;
323 }
324
325 sub getfield ($$) {
326     my ($dctrl,$field) = @_;
327     my $v = $dctrl->{$field};
328     return $v if defined $v;
329     fail "missing field $field in ".$v->get_option('name');
330 }
331
332 sub parsechangelog {
333     my $c = Dpkg::Control::Hash->new();
334     my $p = new IO::Handle;
335     my @cmd = (qw(dpkg-parsechangelog));
336     open $p, '-|', @cmd or die $!;
337     $c->parse($p);
338     $?=0; $!=0; close $p or failedcmd @cmd;
339     return $c;
340 }
341
342 our %rmad;
343
344 sub archive_query ($) {
345     my ($method) = @_;
346     my $query = access_cfg('archive-query','RETURN-UNDEF');
347     if (!defined $query) {
348         my $distro = access_distro();
349         if ($distro eq 'debian') {
350             $query = "sshdakls:".
351                 access_someuserhost('sshdakls').':'.
352                 access_cfg('sshdakls-dir');
353         } else {
354             $query = "madison:$distro";
355         }
356     }
357     $query =~ s/^(\w+):// or badcfg "invalid archive-query method \`$query'";
358     my $proto = $1;
359     my $data = $'; #';
360     { no strict qw(refs); &{"${method}_${proto}"}($proto,$data); }
361 }
362
363 sub archive_query_madison ($$) {
364     my ($proto,$data) = @_;
365     die unless $proto eq 'madison';
366     $rmad{$package} ||= cmdoutput
367         qw(rmadison -asource),"-s$isuite","-u$data",$package;
368     my $rmad = $rmad{$package};
369     return madison_parse($rmad);
370 }
371
372 sub archive_query_sshdakls ($$) {
373     my ($proto,$data) = @_;
374     $data =~ s/:.*// or badcfg "invalid sshdakls method string \`$data'";
375     my $dakls = cmdoutput
376         access_cfg('ssh'), $data, qw(dak ls -asource),"-s$isuite",$package;
377     return madison_parse($dakls);
378 }
379
380 sub canonicalise_suite_sshdakls ($$) {
381     my ($proto,$data) = @_;
382     $data =~ m/:/ or badcfg "invalid sshdakls method string \`$data'";
383     my @cmd =
384         (access_cfg('ssh'), $`,
385          "set -e; cd $';".
386          " if test -h $isuite; then readlink $isuite; exit 0; fi;".
387          " if test -d $isuite; then echo $isuite; exit 0; fi;".
388          " exit 1");
389     my $dakls = cmdoutput @cmd;
390     failedcmd @cmd unless $dakls =~ m/^\w/;
391     return $dakls;
392 }
393
394 sub madison_parse ($) {
395     my ($rmad) = @_;
396     my @out;
397     foreach my $l (split /\n/, $rmad) {
398         $l =~ m{^ \s*( [^ \t|]+ )\s* \|
399                   \s*( [^ \t|]+ )\s* \|
400                   \s*( [^ \t|/]+ )(?:/([^ \t|/]+))? \s* \|
401                   \s*( [^ \t|]+ )\s* }x or die "$rmad $?";
402         $1 eq $package or die "$rmad $package ?";
403         my $vsn = $2;
404         my $newsuite = $3;
405         my $component;
406         if (defined $4) {
407             $component = $4;
408         } else {
409             $component = access_cfg('archive-query-default-component');
410         }
411         $5 eq 'source' or die "$rmad ?";
412         my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
413         my $subpath = "/pool/$component/$prefix/$package/".dscfn($vsn);
414         push @out, [$vsn,$subpath,$newsuite];
415     }
416     return sort { -version_compare_string($a->[0],$b->[0]); } @out;
417 }
418
419 sub canonicalise_suite_madison ($$) {
420     my @r = archive_query_madison($_[0],$_[1]);
421     @r or fail
422         "unable to canonicalise suite using package $package".
423         " which does not appear to exist in suite $isuite;".
424         " --existing-package may help";
425     return $r[0][2];
426 }
427
428 sub canonicalise_suite () {
429     return if defined $csuite;
430     fail "cannot operate on $isuite suite" if $isuite eq 'UNRELEASED';
431     $csuite = archive_query('canonicalise_suite');
432     if ($isuite ne $csuite) {
433         # madison canonicalises for us
434         print "canonical suite name for $isuite is $csuite\n";
435     }
436 }
437
438 sub get_archive_dsc () {
439     canonicalise_suite();
440     my @vsns = archive_query('archive_query');
441     foreach my $vinfo (@vsns) {
442         my ($vsn,$subpath) = @$vinfo;
443         $dscurl = access_cfg('mirror').$subpath;
444         $dscdata = url_get($dscurl);
445         next unless defined $dscdata;
446         $dscurl = access_cfg('mirror').$subpath;
447         $dscdata = url_get($dscurl);
448         my $dscfh = new IO::File \$dscdata, '<' or die $!;
449         print DEBUG Dumper($dscdata) if $debug>1;
450         $dsc = parsecontrolfh($dscfh,$dscurl, allow_pgp=>1);
451         print DEBUG Dumper($dsc) if $debug>1;
452         my $fmt = getfield $dsc, 'Format';
453         fail "unsupported source format $fmt, sorry" unless $format_ok{$fmt};
454         return $dsc;
455     }
456     return undef;
457 }
458
459 sub check_for_git () {
460     # returns 0 or 1
461     my $how = access_cfg('git-check');
462     if ($how eq 'ssh-cmd') {
463         my @cmd =
464             (access_cfg('ssh'),access_gituserhost(),
465              " set -e; cd ".access_cfg('git-path').";".
466              " if test -d $package.git; then echo 1; else echo 0; fi");
467         my $r= cmdoutput @cmd;
468         failedcmd @cmd unless $r =~ m/^[01]$/;
469         return $r+0;
470     } else {
471         badcfg "unknown git-check \`$how'";
472     }
473 }
474
475 sub create_remote_git_repo () {
476     my $how = access_cfg('git-create');
477     if ($how eq 'ssh-cmd') {
478         runcmd_ordryrun
479             (access_cfg('ssh'),access_gituserhost(),
480              "set -e; cd ".access_cfg('git-path').";".
481              " cp -a _template $package.git");
482     } else {
483         badcfg "unknown git-create \`$how'";
484     }
485 }
486
487 our ($dsc_hash,$upload_hash);
488
489 our $ud = '.git/dgit/unpack';
490
491 sub prep_ud () {
492     rmtree($ud);
493     mkpath '.git/dgit';
494     mkdir $ud or die $!;
495 }
496
497 sub mktree_in_ud_from_only_subdir () {
498     # changes into the subdir
499     my (@dirs) = <*/.>;
500     die unless @dirs==1;
501     $dirs[0] =~ m#^([^/]+)/\.$# or die;
502     my $dir = $1;
503     chdir $dir or die "$dir $!";
504     fail "source package contains .git directory" if stat '.git';
505     die $! unless $!==&ENOENT;
506     runcmd qw(git init -q);
507     rmtree('.git/objects');
508     symlink '../../../../objects','.git/objects' or die $!;
509     runcmd @git, qw(add -Af);
510     my $tree = cmdoutput @git, qw(write-tree);
511     $tree =~ m/^\w+$/ or die "$tree ?";
512     return ($tree,$dir);
513 }
514
515 sub dsc_files () {
516     my $field = $dsc->{'Checksums-Sha256'} || $dsc->{Files};
517     defined $field or
518         fail "missing both Checksums-Sha256 and Files in ".
519         $dsc->get_option('name');
520     map {
521         m/^\w+ \d+ (\S+)$/ or
522             fail "could not parse .dsc Files/Checksums line \`$_'";
523         $1;
524     } grep m/\S/, split /\n/, $field;
525 }
526
527 sub is_orig_file ($) {
528     local ($_) = @_;
529     m/\.orig(?:-\w+)?\.tar\.\w+$/;
530 }
531
532 sub make_commit ($) {
533     my ($file) = @_;
534     return cmdoutput @git, qw(hash-object -w -t commit), $file;
535 }
536
537 sub generate_commit_from_dsc () {
538     prep_ud();
539     chdir $ud or die $!;
540     my @files;
541     foreach my $f (dsc_files()) {
542         die "$f ?" if $f =~ m#/|^\.|\.dsc$|\.tmp$#;
543         push @files, $f;
544         link "../../../$f", $f
545             or $!==&ENOENT
546             or die "$f $!";
547     }
548     runcmd @dget, qw(--), $dscurl;
549     foreach my $f (grep { is_orig_file($_) } @files) {
550         link $f, "../../../../$f"
551             or $!==&EEXIST
552             or die "$f $!";
553     }
554     my ($tree,$dir) = mktree_in_ud_from_only_subdir();
555     runcmd qw(sh -ec), 'dpkg-parsechangelog >../changelog.tmp';
556     my $clogp = parsecontrol('../changelog.tmp',"commit's changelog");
557     my $date = cmdoutput qw(date), '+%s %z', qw(-d), getfield($clogp,'Date');
558     my $author = getfield $clogp, 'Maintainer';
559     $author =~ s#,.*##ms;
560     my $authline = "$author $date";
561     $authline =~ m/^[^<>]+ \<\S+\> \d+ [-+]\d+$/ or
562         fail "unexpected commit author line format \`$authline'".
563             " (was generated from changelog Maintainer field)";
564     my $changes = getfield $clogp, 'Changes';
565     open C, ">../commit.tmp" or die $!;
566     print C <<END or die $!;
567 tree $tree
568 author $authline
569 committer $authline
570
571 $changes
572
573 # imported from the archive
574 END
575     close C or die $!;
576     my $outputhash = make_commit qw(../commit.tmp);
577     my $cversion = getfield $clogp, 'Version';
578     print "synthesised git commit from .dsc $cversion\n";
579     if ($upload_hash) {
580         runcmd @git, qw(reset --hard), $upload_hash;
581         runcmd qw(sh -ec), 'dpkg-parsechangelog >>../changelogold.tmp';
582         my $oldclogp = parsecontrol('../changelogold.tmp','previous changelog');
583         my $oversion = getfield $oldclogp, 'Version';
584         my $vcmp =
585             version_compare_string($oversion, $cversion);
586         if ($vcmp < 0) {
587             # git upload/ is earlier vsn than archive, use archive
588             open C, ">../commit2.tmp" or die $!;
589             print C <<END or die $!;
590 tree $tree
591 parent $upload_hash
592 parent $outputhash
593 author $authline
594 committer $authline
595
596 Record $package ($cversion) in archive suite $csuite
597 END
598             $outputhash = make_commit qw(../commit2.tmp);
599         } elsif ($vcmp > 0) {
600             print STDERR <<END or die $!;
601
602 Version actually in archive:    $cversion (older)
603 Last allegedly pushed/uploaded: $oversion (newer or same)
604 $later_warning_msg
605 END
606             $outputhash = $upload_hash;
607         } else {
608             $outputhash = $upload_hash;
609         }
610     }
611     chdir '../../../..' or die $!;
612     runcmd @git, qw(update-ref -m),"dgit fetch import $cversion",
613             'DGIT_ARCHIVE', $outputhash;
614     cmdoutput @git, qw(log -n2), $outputhash;
615     # ... gives git a chance to complain if our commit is malformed
616     rmtree($ud);
617     return $outputhash;
618 }
619
620 sub ensure_we_have_orig () {
621     foreach my $f (dsc_files()) {
622         next unless is_orig_file($f);
623         if (stat "../$f") {
624             die "$f ?" unless -f _;
625         } else {
626             die "$f $!" unless $!==&ENOENT;
627         }
628         my $origurl = $dscurl;
629         $origurl =~ s{/[^/]+$}{};
630         $origurl .= "/$f";
631         die "$f ?" unless $f =~ m/^${package}_/;
632         die "$f ?" if $f =~ m#/#;
633         runcmd_ordryrun qw(sh -ec),'cd ..; exec "$@"','x',
634             @dget,'--',$origurl;
635     }
636 }
637
638 sub rev_parse ($) {
639     return cmdoutput @git, qw(rev-parse), "$_[0]~0";
640 }
641
642 sub is_fast_fwd ($$) {
643     my ($ancestor,$child) = @_;
644     my @cmd = (@git, qw(merge-base), $ancestor, $child);
645     my $mb = cmdoutput_errok @cmd;
646     if (defined $mb) {
647         return rev_parse($mb) eq rev_parse($ancestor);
648     } else {
649         $?==256 or failedcmd @cmd;
650         return 0;
651     }
652 }
653
654 sub git_fetch_us () {
655     badusage "cannot dry run with fetch" if $dryrun;
656     runcmd @git, qw(fetch),access_giturl(),fetchspec();
657 }
658
659 sub fetch_from_archive () {
660     # ensures that lrref() is what is actually in the archive,
661     #  one way or another
662     get_archive_dsc() or return 0;
663     foreach my $field (@ourdscfield) {
664         $dsc_hash = $dsc->{$field};
665         last if defined $dsc_hash;
666     }
667     if (defined $dsc_hash) {
668         $dsc_hash =~ m/\w+/ or fail "invalid hash in .dsc \`$dsc_hash'";
669         $dsc_hash = $&;
670         print "last upload to archive specified git hash\n";
671     } else {
672         print "last upload to archive has NO git hash\n";
673     }
674
675     my $lrref_fn = ".git/".lrref();
676     if (open H, $lrref_fn) {
677         $upload_hash = <H>;
678         chomp $upload_hash;
679         die "$lrref_fn $upload_hash ?" unless $upload_hash =~ m/^\w+$/;
680     } elsif ($! == &ENOENT) {
681         $upload_hash = '';
682     } else {
683         die "$lrref_fn $!";
684     }
685     print DEBUG "previous reference hash=$upload_hash\n";
686     my $hash;
687     if (defined $dsc_hash) {
688         fail "missing git history even though dsc has hash -".
689             " could not find commit $dsc_hash".
690             " (should be in ".access_giturl()."#".rrref().")"
691             unless $upload_hash;
692         $hash = $dsc_hash;
693         ensure_we_have_orig();
694         if ($dsc_hash eq $upload_hash) {
695         } elsif (is_fast_fwd($dsc_hash,$upload_hash)) {
696             print STDERR <<END or die $!;
697
698 Git commit in archive is behind the last version allegedly pushed/uploaded.
699 Commit referred to by archive:  $dsc_hash
700 Last allegedly pushed/uploaded: $upload_hash
701 $later_warning_msg
702 END
703             $hash = $upload_hash;
704         } else {
705             fail "archive's .dsc refers to ".$dsc_hash.
706                 " but this is an ancestor of ".$upload_hash;
707         }
708     } else {
709         $hash = generate_commit_from_dsc();
710     }
711     print DEBUG "current hash=$hash\n";
712     if ($upload_hash) {
713         fail "not fast forward on last upload branch!".
714             " (archive's version left in DGIT_ARCHIVE)"
715             unless is_fast_fwd($upload_hash, $hash);
716     }
717     if ($upload_hash ne $hash) {
718         my @upd_cmd = (@git, qw(update-ref -m), 'dgit fetch', lrref(), $hash);
719         if (!$dryrun) {
720             cmdoutput @upd_cmd;
721         } else {
722             dryrun_report @upd_cmd;
723         }
724     }
725     return 1;
726 }
727
728 sub clone ($) {
729     my ($dstdir) = @_;
730     canonicalise_suite();
731     badusage "dry run makes no sense with clone" if $dryrun;
732     mkdir $dstdir or die "$dstdir $!";
733     chdir "$dstdir" or die "$dstdir $!";
734     runcmd @git, qw(init -q);
735     runcmd @git, qw(config), "remote.$remotename.fetch", fetchspec();
736     open H, "> .git/HEAD" or die $!;
737     print H "ref: ".lref()."\n" or die $!;
738     close H or die $!;
739     runcmd @git, qw(remote add), 'origin', access_giturl();
740     if (check_for_git()) {
741         print "fetching existing git history\n";
742         git_fetch_us();
743         runcmd @git, qw(fetch origin);
744     } else {
745         print "starting new git history\n";
746     }
747     fetch_from_archive() or no_such_package;
748     runcmd @git, qw(reset --hard), lrref();
749     printdone "ready for work in $dstdir";
750 }
751
752 sub fetch () {
753     if (check_for_git()) {
754         git_fetch_us();
755     }
756     fetch_from_archive() or no_such_package();
757     printdone "fetched into ".lrref();
758 }
759
760 sub pull () {
761     fetch();
762     runcmd_ordryrun @git, qw(merge -m),"Merge from $csuite [dgit]",
763         lrref();
764     printdone "fetched to ".lrref()." and merged into HEAD";
765 }
766
767 sub check_not_dirty () {
768     return if $ignoredirty;
769     my @cmd = (@git, qw(diff --quiet HEAD));
770     printcmd(\*DEBUG,"+",@cmd) if $debug>0;
771     $!=0; $?=0; system @cmd;
772     return if !$! && !$?;
773     if (!$! && $?==256) {
774         fail "working tree is dirty (does not match HEAD)";
775     } else {
776         failedcmd @cmd;
777     }
778 }
779
780 sub commit_quilty_patch () {
781     my $output = cmdoutput @git, qw(status --porcelain);
782     my %adds;
783     my $bad=0;
784     foreach my $l (split /\n/, $output) {
785         next unless $l =~ m/\S/;
786         if ($l =~ m{^(?:\?\?| M) (.pc|debian/patches)}) {
787             $adds{$1}++;
788         } else {
789             print STDERR "git status: $l\n";
790             $bad++;
791         }
792     }
793     fail "unexpected output from git status (is tree clean?)" if $bad;
794     if (!%adds) {
795         print "nothing quilty to commit, ok.\n";
796         return;
797     }
798     runcmd_ordryrun @git, qw(add), sort keys %adds;
799     my $m = "Commit Debian 3.0 (quilt) metadata";
800     print "$m\n";
801     runcmd_ordryrun @git, qw(commit -m), $m;
802 }
803
804 sub madformat ($) {
805     my ($format) = @_;
806     return 0 unless $format eq '3.0 (quilt)';
807     print "Format \`$format', urgh\n";
808     if ($noquilt) {
809         print "Not doing any fixup of \`$format' due to --no-quilt-fixup";
810         return 0;
811     }
812     return 1;
813 }
814
815 sub dopush () {
816     print DEBUG "actually entering push\n";
817     my $clogp = parsechangelog();
818     $package = getfield $clogp, 'Source';
819     my $cversion = getfield $clogp, 'Version';
820     my $dscfn = dscfn($cversion);
821     stat "../$dscfn" or
822         fail "looked for .dsc $dscfn, but $!;".
823             " maybe you forgot to build";
824     $dsc = parsecontrol("../$dscfn","$dscfn");
825     my $dscpackage = getfield $dsc, 'Source';
826     my $format = getfield $dsc, 'Format';
827     my $dversion = getfield $dsc, 'Version';
828     ($dscpackage eq $package && $dversion eq $cversion) or
829         fail "$dsc is for $dscpackage $dversion".
830             " but debian/changelog is for $package $cversion";
831     print DEBUG "format $format\n";
832     if (madformat($format)) {
833         commit_quilty_patch();
834     }
835     check_not_dirty();
836     prep_ud();
837     chdir $ud or die $!;
838     print "checking that $dscfn corresponds to HEAD\n";
839     runcmd qw(dpkg-source -x --), "../../../../$dscfn";
840     my ($tree,$dir) = mktree_in_ud_from_only_subdir();
841     chdir '../../../..' or die $!;
842     printcmd \*DEBUG,"+",@_;
843     my @diffcmd = (@git, qw(diff --exit-code), $tree);
844     $!=0; $?=0;
845     if (system @diffcmd) {
846         if ($! && $?==256) {
847             fail "$dscfn specifies a different tree to your HEAD commit;".
848                 " perhaps you forgot to build";
849         } else {
850             failedcmd @diffcmd;
851         }
852     }
853 #fetch from alioth
854 #do fast forward check and maybe fake merge
855 #    if (!is_fast_fwd(mainbranch
856 #    runcmd @git, qw(fetch -p ), "$alioth_git/$package.git",
857 #        map { lref($_).":".rref($_) }
858 #        (uploadbranch());
859     $dsc->{$ourdscfield[0]} = rev_parse('HEAD');
860     $dsc->save("../$dscfn.tmp") or die $!;
861     if (!$changesfile) {
862         my $multi = "../${package}_".(stripepoch $cversion)."_multi.changes";
863         if (stat "$multi") {
864             $changesfile = $multi;
865         } else {
866             $!==&ENOENT or die "$multi: $!";
867             my $pat = "${package}_".(stripepoch $cversion)."_*.changes";
868             my @cs = glob "../$pat";
869             fail "failed to find unique changes file".
870                 " (looked for $pat in .., or $multi);".
871                 " perhaps you need to use dgit -C"
872                 unless @cs==1;
873             ($changesfile) = @cs;
874         }
875     }
876     my $changes = parsecontrol($changesfile,$changesfile);
877     foreach my $field (qw(Source Distribution Version)) {
878         $changes->{$field} eq $clogp->{$field} or
879             fail "changes field $field \`$changes->{$field}'".
880                 " does not match changelog \`$clogp->{$field}'";
881     }
882     my $tag = debiantag($dversion);
883     if (!check_for_git()) {
884         create_remote_git_repo();
885     }
886     runcmd_ordryrun @git, qw(push),access_giturl(),"HEAD:".rrref();
887     if (!$dryrun) {
888         rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
889     } else {
890         print "[new .dsc left in $dscfn.tmp]\n";
891     }
892     if ($sign) {
893         if (!defined $keyid) {
894             $keyid = access_cfg('keyid','RETURN-UNDEF');
895         }
896         my @tag_cmd = (@git, qw(tag -s -m),
897                        "Release $dversion for $csuite [dgit]");
898         push @tag_cmd, qw(-u),$keyid if defined $keyid;
899         push @tag_cmd, $tag;
900         runcmd_ordryrun @tag_cmd;
901         my @debsign_cmd = @debsign;
902         push @debsign_cmd, "-k$keyid" if defined $keyid;
903         push @debsign_cmd, $changesfile;
904         runcmd_ordryrun @debsign_cmd;
905     }
906     runcmd_ordryrun @git, qw(push),access_giturl(),"refs/tags/$tag";
907     my $host = access_cfg('upload-host','RETURN-UNDEF');
908     my @hostarg = defined($host) ? ($host,) : ();
909     runcmd_ordryrun @dput, @hostarg, $changesfile;
910     printdone "pushed and uploaded $dversion";
911 }
912
913 sub cmd_clone {
914     parseopts();
915     my $dstdir;
916     badusage "-p is not allowed with clone; specify as argument instead"
917         if defined $package;
918     if (@ARGV==1) {
919         ($package) = @ARGV;
920     } elsif (@ARGV==2 && $ARGV[1] =~ m#^\w#) {
921         ($package,$isuite) = @ARGV;
922     } elsif (@ARGV==2 && $ARGV[1] =~ m#^[./]#) {
923         ($package,$dstdir) = @ARGV;
924     } elsif (@ARGV==3) {
925         ($package,$isuite,$dstdir) = @ARGV;
926     } else {
927         badusage "incorrect arguments to dgit clone";
928     }
929     $dstdir ||= "$package";
930     clone($dstdir);
931 }
932
933 sub branchsuite () {
934     my $branch = cmdoutput_errok @git, qw(symbolic-ref HEAD);
935     if ($branch =~ m#$lbranch_re#o) {
936         return $1;
937     } else {
938         return undef;
939     }
940 }
941
942 sub fetchpullargs () {
943     if (!defined $package) {
944         my $sourcep = parsecontrol('debian/control','debian/control');
945         $package = getfield $sourcep, 'Source';
946     }
947     if (@ARGV==0) {
948 #       $isuite = branchsuite();  # this doesn't work because dak hates canons
949         if (!$isuite) {
950             my $clogp = parsechangelog();
951             $isuite = getfield $clogp, 'Distribution';
952         }
953         canonicalise_suite();
954         print "fetching from suite $csuite\n";
955     } elsif (@ARGV==1) {
956         ($isuite) = @ARGV;
957         canonicalise_suite();
958     } else {
959         badusage "incorrect arguments to dgit fetch or dgit pull";
960     }
961 }
962
963 sub cmd_fetch {
964     parseopts();
965     fetchpullargs();
966     fetch();
967 }
968
969 sub cmd_pull {
970     parseopts();
971     fetchpullargs();
972     pull();
973 }
974
975 sub cmd_push {
976     parseopts();
977     badusage "-p is not allowed with dgit push" if defined $package;
978     check_not_dirty();
979     my $clogp = parsechangelog();
980     $package = getfield $clogp, 'Source';
981     if (@ARGV==0) {
982         $isuite = getfield $clogp, 'Distribution';
983         if ($new_package) {
984             local ($package) = $existing_package; # this is a hack
985             canonicalise_suite();
986         }
987     } else {
988         badusage "incorrect arguments to dgit push";
989     }
990     if (check_for_git()) {
991         git_fetch_us();
992     }
993     if (fetch_from_archive()) {
994         is_fast_fwd(lrref(), 'HEAD') or
995             fail "dgit push: HEAD is not a descendant".
996                 " of the archive's version.\n".
997                 "$us: To overwrite it, use git-merge -s ours ".lrref().".";
998     } else {
999         $new_package or
1000             fail "package appears to be new in this suite;".
1001                 " if this is intentional, use --new";
1002     }
1003     dopush();
1004 }
1005
1006 our $version;
1007 our $sourcechanges;
1008 our $dscfn;
1009
1010 our $fakeeditorenv = 'DGIT_FAKE_EDITOR_QUILT';
1011
1012 sub build_maybe_quilt_fixup () {
1013     if (!open F, "debian/source/format") {
1014         die $! unless $!==&ENOENT;
1015         return;
1016     }
1017     $_ = <F>;
1018     F->error and die $!;
1019     chomp;
1020     return unless madformat($_);
1021     # sigh
1022     my $clogp = parsechangelog();
1023     my $version = getfield $clogp, 'Version';
1024     my $author = getfield $clogp, 'Maintainer';
1025     my $headref = rev_parse('HEAD');
1026     my $time = time;
1027     my $ncommits = 3;
1028     my $patchname = "auto-$version-$headref-$time";
1029     my $msg = cmdoutput @git, qw(log), "-n$ncommits";
1030     my $descfn = ".git/dgit/quilt-description.tmp";
1031     open O, '>', $descfn or die "$descfn: $!";
1032     $msg =~ s/\n/\n /g;
1033     $msg =~ s/^\s+$/ ./mg;
1034     print O <<END or die $!;
1035 Description: Automatically generated patch ($clogp->{Version})
1036  Last (up to) $ncommits git changes, FYI:
1037  .
1038  $msg
1039 Author: $author
1040
1041 ---
1042
1043 END
1044     close O or die $!;
1045     {
1046         local $ENV{'EDITOR'} = cmdoutput qw(realpath --), $0;
1047         local $ENV{'VISUAL'} = $ENV{'EDITOR'};
1048         local $ENV{$fakeeditorenv} = cmdoutput qw(realpath --), $descfn;
1049         runcmd_ordryrun @dpkgsource, qw(--commit .), $patchname;
1050     }
1051
1052     if (!open P, '>>', ".pc/applied-patches") {
1053         $!==&ENOENT or die $!;
1054     } else {
1055         close P;
1056     }
1057
1058     commit_quilty_patch();
1059 }
1060
1061 sub quilt_fixup_editor () {
1062     my $descfn = $ENV{$fakeeditorenv};
1063     my $editing = $ARGV[$#ARGV];
1064     open I1, '<', $descfn or die "$descfn: $!";
1065     open I2, '<', $editing or die "$editing: $!";
1066     unlink $editing or die "$editing: $!";
1067     open O, '>', $editing or die "$editing: $!";
1068     while (<I1>) { print O or die $!; } I1->error and die $!;
1069     my $copying = 0;
1070     while (<I2>) {
1071         $copying ||= m/^\-\-\- /;
1072         next unless $copying;
1073         print O or die $!;
1074     }
1075     I2->error and die $!;
1076     close O or die $1;
1077     exit 0;
1078 }
1079
1080 sub build_prep () {
1081     badusage "-p is not allowed when building" if defined $package;
1082     check_not_dirty();
1083     my $clogp = parsechangelog();
1084     $isuite = getfield $clogp, 'Distribution';
1085     $package = getfield $clogp, 'Source';
1086     $version = getfield $clogp, 'Version';
1087     build_maybe_quilt_fixup();
1088 }
1089
1090 sub cmd_build {
1091     badusage "dgit build implies --clean=dpkg-source"
1092         if $cleanmode ne 'dpkg-source';
1093     build_prep();
1094     runcmd_ordryrun @dpkgbuildpackage, qw(-us -uc), changesopts(), @ARGV;
1095     printdone "build successful\n";
1096 }
1097
1098 sub cmd_git_build {
1099     badusage "dgit git-build implies --clean=dpkg-source"
1100         if $cleanmode ne 'dpkg-source';
1101     build_prep();
1102     my @cmd =
1103         (qw(git-buildpackage -us -uc --git-no-sign-tags),
1104          "--git-builder=@dpkgbuildpackage");
1105     unless (grep { m/^--git-debian-branch|^--git-ignore-branch/ } @ARGV) {
1106         canonicalise_suite();
1107         push @cmd, "--git-debian-branch=".lbranch();
1108     }
1109     push @cmd, changesopts();
1110     runcmd_ordryrun @cmd, @ARGV;
1111     printdone "build successful\n";
1112 }
1113
1114 sub build_source {
1115     build_prep();
1116     $sourcechanges = "${package}_".(stripepoch $version)."_source.changes";
1117     $dscfn = dscfn($version);
1118     if ($cleanmode eq 'dpkg-source') {
1119         runcmd_ordryrun (@dpkgbuildpackage, qw(-us -uc -S)), changesopts();
1120     } else {
1121         if ($cleanmode eq 'git') {
1122             runcmd_ordryrun @git, qw(clean -xdf);
1123         } elsif ($cleanmode eq 'none') {
1124         } else {
1125             die "$cleanmode ?";
1126         }
1127         my $pwd = cmdoutput qw(env - pwd);
1128         my $leafdir = basename $pwd;
1129         chdir ".." or die $!;
1130         runcmd_ordryrun @dpkgsource, qw(-b --), $leafdir;
1131         chdir $pwd or die $!;
1132         runcmd_ordryrun qw(sh -ec),
1133             'exec >$1; shift; exec "$@"','x',
1134             "../$sourcechanges",
1135             @dpkggenchanges, qw(-S), changesopts();
1136     }
1137 }
1138
1139 sub cmd_build_source {
1140     badusage "build-source takes no additional arguments" if @ARGV;
1141     build_source();
1142     printdone "source built, results in $dscfn and $sourcechanges";
1143 }
1144
1145 sub cmd_sbuild {
1146     build_source();
1147     chdir ".." or die $!;
1148     my $pat = "${package}_".(stripepoch $version)."_*.changes";
1149     if (!$dryrun) {
1150         stat $dscfn or fail "$dscfn (in parent directory): $!";
1151         stat $sourcechanges or fail "$sourcechanges (in parent directory): $!";
1152         foreach my $cf (glob $pat) {
1153             next if $cf eq $sourcechanges;
1154             unlink $cf or fail "remove $cf: $!";
1155         }
1156     }
1157     runcmd_ordryrun @sbuild, @ARGV, qw(-d), $isuite, $dscfn;
1158     runcmd_ordryrun @mergechanges, glob $pat;
1159     my $multichanges = "${package}_".(stripepoch $version)."_multi.changes";
1160     if (!$dryrun) {
1161         stat $multichanges or fail "$multichanges: $!";
1162     }
1163     printdone "build successful, results in $multichanges\n" or die $!;
1164 }    
1165
1166 sub cmd_quilt_fixup {
1167     badusage "incorrect arguments to dgit quilt-fixup" if @ARGV;
1168     my $clogp = parsechangelog();
1169     $version = getfield $clogp, 'Version';
1170     build_maybe_quilt_fixup();
1171 }
1172
1173 sub parseopts () {
1174     my $om;
1175     while (@ARGV) {
1176         last unless $ARGV[0] =~ m/^-/;
1177         $_ = shift @ARGV;
1178         last if m/^--?$/;
1179         if (m/^--/) {
1180             if (m/^--dry-run$/) {
1181                 $dryrun=1;
1182             } elsif (m/^--no-sign$/) {
1183                 $sign=0;
1184             } elsif (m/^--help$/) {
1185                 helponly();
1186             } elsif (m/^--new$/) {
1187                 $new_package=1;
1188             } elsif (m/^--(\w+)=(.*)/s &&
1189                      ($om = $opts_opt_map{$1}) &&
1190                      length $om->[0]) {
1191                 $om->[0] = $2;
1192             } elsif (m/^--(\w+):(.*)/s &&
1193                      ($om = $opts_opt_map{$1})) {
1194                 push @$om, $2;
1195             } elsif (m/^--existing-package=(.*)/s) {
1196                 $existing_package = $1;
1197             } elsif (m/^--distro=(.*)/s) {
1198                 $idistro = $1;
1199             } elsif (m/^--clean=(dpkg-source|git|none)$/s) {
1200                 $cleanmode = $1;
1201             } elsif (m/^--clean=(.*)$/s) {
1202                 badusage "unknown cleaning mode \`$1'";
1203             } elsif (m/^--ignore-dirty$/s) {
1204                 $ignoredirty = 1;
1205             } elsif (m/^--no-quilt-fixup$/s) {
1206                 $noquilt = 1;
1207             } else {
1208                 badusage "unknown long option \`$_'";
1209             }
1210         } else {
1211             while (m/^-./s) {
1212                 if (s/^-n/-/) {
1213                     $dryrun=1;
1214                 } elsif (s/^-h/-/) {
1215                     helponly();
1216                 } elsif (s/^-D/-/) {
1217                     open DEBUG, ">&STDERR" or die $!;
1218                     $debug++;
1219                 } elsif (s/^-N/-/) {
1220                     $new_package=1;
1221                 } elsif (m/^-[vm]/) {
1222                     push @changesopts, $_;
1223                     $_ = '';
1224                 } elsif (s/^-c(.*=.*)//s) {
1225                     push @git, '-c', $1;
1226                 } elsif (s/^-d(.*)//s) {
1227                     $idistro = $1;
1228                 } elsif (s/^-C(.*)//s) {
1229                     $changesfile = $1;
1230                 } elsif (s/^-k(.*)//s) {
1231                     $keyid=$1;
1232                 } elsif (s/^-wn//s) {
1233                     $cleanmode = 'none';
1234                 } elsif (s/^-wg//s) {
1235                     $cleanmode = 'git';
1236                 } elsif (s/^-wd//s) {
1237                     $cleanmode = 'dpkg-source';
1238                 } else {
1239                     badusage "unknown short option \`$_'";
1240                 }
1241             }
1242         }
1243     }
1244 }
1245
1246 if ($ENV{$fakeeditorenv}) {
1247     quilt_fixup_editor();
1248 }
1249
1250 parseopts();
1251 print STDERR "DRY RUN ONLY\n" if $dryrun;
1252 if (!@ARGV) {
1253     print STDERR $helpmsg or die $!;
1254     exit 8;
1255 }
1256 my $cmd = shift @ARGV;
1257 $cmd =~ y/-/_/;
1258 { no strict qw(refs); &{"cmd_$cmd"}(); }